
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class LocationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.create(
            {
                id: data.id || undefined,
        
        label: data.label
        ||
        null
            ,
            
        city: data.city
        ||
        null
            ,
            
        state: data.state
        ||
        null
            ,
            
        zip: data.zip
        ||
        null
            ,
            
        lat: data.lat
        ||
        null
            ,
            
        lng: data.lng
        ||
        null
            ,
            
        tenant_key: data.tenant_key
        ||
        null
            ,
            
        created_at_ts: data.created_at_ts
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return locations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const locationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                label: item.label
            ||
            null
            ,
            
                city: item.city
            ||
            null
            ,
            
                state: item.state
            ||
            null
            ,
            
                zip: item.zip
            ||
            null
            ,
            
                lat: item.lat
            ||
            null
            ,
            
                lng: item.lng
            ||
            null
            ,
            
                tenant_key: item.tenant_key
            ||
            null
            ,
            
                created_at_ts: item.created_at_ts
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const locations = await db.locations.bulkCreate(locationsData, { transaction });

        // For each item created, replace relation files
        

        return locations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const locations = await db.locations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.label !== undefined) updatePayload.label = data.label;
        
        
        if (data.city !== undefined) updatePayload.city = data.city;
        
        
        if (data.state !== undefined) updatePayload.state = data.state;
        
        
        if (data.zip !== undefined) updatePayload.zip = data.zip;
        
        
        if (data.lat !== undefined) updatePayload.lat = data.lat;
        
        
        if (data.lng !== undefined) updatePayload.lng = data.lng;
        
        
        if (data.tenant_key !== undefined) updatePayload.tenant_key = data.tenant_key;
        
        
        if (data.created_at_ts !== undefined) updatePayload.created_at_ts = data.created_at_ts;
        
        
        updatePayload.updatedById = currentUser.id;

        await locations.update(updatePayload, {transaction});

        
        

        
        

        

        return locations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of locations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of locations) {
                await record.destroy({transaction});
            }
        });


        return locations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.findByPk(id, options);

        await locations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await locations.destroy({
            transaction
        });

        return locations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const locations = await db.locations.findOne(
            { where },
            { transaction },
        );

        if (!locations) {
            return locations;
        }

        const output = locations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.label) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'label',
                        filter.label,
                    ),
                };
            }
            
            if (filter.city) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'city',
                        filter.city,
                    ),
                };
            }
            
            if (filter.state) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'state',
                        filter.state,
                    ),
                };
            }
            
            if (filter.zip) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'zip',
                        filter.zip,
                    ),
                };
            }
            
            if (filter.tenant_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'locations',
                        'tenant_key',
                        filter.tenant_key,
                    ),
                };
            }
            

            
            

            
            if (filter.latRange) {
                const [start, end] = filter.latRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    lat: {
                    ...where.lat,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    lat: {
                    ...where.lat,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.lngRange) {
                const [start, end] = filter.lngRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    lng: {
                    ...where.lng,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    lng: {
                    ...where.lng,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.created_at_tsRange) {
                const [start, end] = filter.created_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.locations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'locations',
                        'label',
                        query,
                    ),
                ],
            };
        }

        const records = await db.locations.findAll({
            attributes: [ 'id', 'label' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['label', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.label,
        }));
    }

    
};

